#include <iostream>
using namespace std;
long long spiral[1000][1000];
int main ()
{
    int n,m,p;
    cin>>m>>n>>p;
    int x=0, y=0, i=1, j=0;
    spiral[x][y]=m;
    int kopie=n;
    while(i<=kopie*kopie)
    {
        if(j%4==0) ++x;
        if(j%4==1) ++y;
        if(j%4==2) --x;
        if(j%4==3) --y;
        if(x+1==n || y+1==n) j++;
        x=x%n;   y=y%n;   x=x%n;   y=y%n;
        spiral[x][y]=m+i;
        ++i;
        //cout<<"a";
    }
    int sbor=0;
    for(int a=0; a<kopie; a++){
        sbor+=spiral[a][p];
    }
    cout<<sbor;
    return 0;
}

